<#parameter inputname="diagramid">
<#variable name="actions" value=="From('[' + [diagramid] + '].subobjects.actions', '', 'typename,name', 'id,name(as=\"actionname\"),typename,createddate,creator.fullname,creator.name,externalparentobjects(as=\"relatedObjects\")')">
<h2 id="header<#diagramid>"><#attribute object=="[diagramid]" attribute="name"></h2>
<img src="/QPRWebServicesExtensions/GetGraph.ashx?objectid=<#diagramid>&options=graphtype=processlevel&sessionId=<#expression value=="WsSessionId()">" />
<table>
<tr>
  <th>Element name</th>
  <th>Type</th>
  <th>Symbol</th>
  <th>Description</th>
</tr>
<#loop tpl="Element" query=="'[' + [diagramid] + '].subobjects'" criteria="typegroupname<>\"Connector\"" attributes="name(as=\"elementname\"),typename,symbol,description" sortby="typename,name" loopparameter="objectid">
</table>
<#dataset visible=="DatasetSize(actions)>0" data=="[actions]" rowtemplate="ActionRow" headertemplate="ActionsHeader" footertemplate="ActionsFooter">
<#expression visible=="DatasetSize(actions)=0" value="<p>[No actions added]</p>">
<#loop tpl="Diagram" query=="'[' + [diagramid] + '].childobjects(hierarchy=\"processlevels\")'" sortby="name" loopparameter="diagramid">