<!DOCTYPE html>
<#parameter inputname="diagramid">
<#variable name="realDiagramid" value=="if(Substring([diagramid], Length([diagramid])-2, 2)='.0', QueryObjectsFirstAttribute('[' + [diagramid] + '].HierarchyRoots(hierarchy=\"processlevels\")', '', '', 'id', ''), [diagramid])">
<html>
  <head>
    <title>Process report</title>
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta http-equiv="content-type" content="text/html;charset=UTF-8" />
	<script type="text/javascript" src="/<#expression value=="ApplicationSetting('qprwebapplicationname')">/qprsoftware/common/scripts/jquery.js"></script>
  <style>
 table {
   border-collapse: collapse;
   margin: 10px 0px 0px 0px;
 }
 
 table td, table th {
   font-size: 12px;
   border: 1px solid #9b9696;
   padding: 2px 3px 2px 4px;
 }
 
 table th {
   font-size: 13px;
   text-align: left;
   padding-top: 2px;
   padding-bottom: 2px;
   background-color: #9b9696;
   color: #ffffff;
 }
 
 img {
   margin: 10px 0px 10px 5px;
   max-width: 1100px;
 }
</style>
<script>
function openPortalLink(objectId, viewName, options, openInNewWindow) {
$.get( "/QPRWebServicesExtensions/GetPortalUrl.ashx?wssession=<#expression value=="WsSessionId()">&objectid=" + objectId + "&viewname=" + viewName + "&options=" + options,
  function(url) {
    if (url != null && url != "") {
	  if (openInNewWindow) {
	    window.open(url);
	  } else { 
		window.location.href = url;
	  }
	}
  })
}
</script>

</head>
  <body>
    <h1>Process report - <#attribute object=="[realDiagramid]" attribute="name"></h1>
    <#template tpl="toc" diagramid=="[realDiagramid]" level=="0" diagramname=="GetAttribute([realDiagramid], 'name', '')">
    <#template tpl="diagram" diagramid=="[realDiagramid]">
  </body>
</html>