<%@ Page Language="C#" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <title>QPR WSF Service Tester</title>

<style type="text/css">
body, body * {
  font-family: Tahoma, Arial, Helvetica, Geneva, Swiss, SunSans-Regular;
  font-size: 12px;
}
a {
  color: #3366CC;
  text-decoration: none;
}
a:hover {
  text-decoration: underline;
}
.Button {
  font-weight: normal;
  color: #666666;
  float: left;
  text-decoration: none;
  padding-right: 6px;
}
.Button:hover {
  text-decoration: underline;
}
a.SelectedButton {
  float: left;
  font-weight: normal;
  color: #FF8900;
  padding-right: 6px;
}
div.Clearer {
  clear: both;
}
textarea {
  font-family: monospace;
}
th {
  text-align: left;
}

#datasettable {
  border-collapse: collapse;
}

#datasettable td, #datasettable th {
  font-size: 12px;
  border: 1px solid #9b9696;
  padding: 2px 3px 2px 4px;
}

#datasettable th {
  font-size: 13px;
  text-align: left;
  padding-top: 2px;
  padding-bottom: 2px;
  background-color: #9b9696;
  color: #ffffff;
}
</style>

<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="jquery.form.js"></script>
<script type="text/javascript" src="json2.js"></script>

<script type="text/javascript">
<!--
  var OP   = (navigator.userAgent.indexOf("Opera") != -1);
  var IEANY= (navigator.userAgent.indexOf("MSIE") != -1) && !OP;

  var _client;
  var _sessionId;
  var _currentOperationPrefix;
  var _currentOperationStartTime;
  var _selectedPage;
  var _pages = ["Authentication", "QueryObjects", "GetAttributes", "GetPortalUrl", "GetBinaryData", "GetGraph", "CreateObject", "CreateCopy", "DeleteObject", "SetAttribute", "SetAttributes", "SetBinaryData", "ModifyReference", "SetAccessLevel", "SetSCMeasureValuesForMeasure", "SetSCMeasureValuesForModel", "RunExpression"];

  function ArrayToString(arrayToConvert)
  {
    return arrayToConvert.slice(0, 32) + "...";
  }
  
  function sGetButtonHTML(vsLabel, vsLinkURL, vsStyle, vsTarget)
  {
    if (!vsStyle)
      vsStyle = "Button";
    if (!vsLabel)
      vsLabel = "&nbsp;";
    var sLink;
    if (vsLinkURL && (vsLinkURL.length > 0))
      sLink = " href='" + vsLinkURL + "'";
    else
      sLink = "";
    if (vsTarget)
      sLink += " target='" + vsTarget + "'";
    return "<a" + sLink + " class='" + vsStyle + "'>[&nbsp;" + vsLabel + "&nbsp;]<\/a>";
  }

  function GetTableAs2DimensionalArray(columns)
  {
    var result = new Array();
    var i = 0;
    while (eval("typeof(document.parameters." + columns[0] + (i + 1).toString() + ") !== \"undefined\"")) {
      var row = new Array();
      for (var j = 0; j < columns.length; ++j)
        row.push(eval("document.parameters." + columns[j] + (i + 1).toString() + ".value"));
      result.push(row);
      ++i;
    }
    return result;
  }

  function SetPasswordBoxType(type)
  {
    try {
      var passwordBox = document.getElementsByName('Authentication_password')[0];
      passwordBox.type = type;
    } catch (err) {}
  }

  function OnStartOperation(operationPrefix)
  {
    _currentOperationPrefix = operationPrefix;
    _currentOperationStartTime = new Date();
  }
  
  function OnEndOperation()
  {
    SetOperationState("Idle");
    var undef;
    var endTime = new Date();
    $("#ElapsedTime").html("Processing took " + ((endTime.getTime() - _currentOperationStartTime.getTime()) / 1000) + " seconds.");
    _currentOperationPrefix = undef;
  }
  
  function SetOperationState(state)
  {
    var stateElement = document.getElementById("OperationState");
    stateElement.innerHTML = state;
  }
  
  function OnRequestError(result)
  {
    alert("Exception occurred while processing request:\r\n" + result.get_message());
    OnEndOperation();
  }
  
  function Authenticate(AuthenticationFinishedHandler)
  {
    if (SSOEnabled()) 
      AuthenticationFinishedHandler("");
    else {
      SetOperationState("Authenticating...");
      _client.Authenticate(document.parameters.Authentication_logonName.value, 
                           document.parameters.Authentication_password.value,
                           AuthenticationFinishedHandler, OnRequestError);
    }
  }

  function LogOff(LogOffFinishedHandler)
  {
    if (SSOEnabled()) 
      LogOffFinishedHandler();
    else {
      SetOperationState("Finishing session...");
      _client.LogOff(_sessionId,
                     LogOffFinishedHandler, OnRequestError);
    }
  }
  
  function OnQueryObjects()
  {
    OnStartOperation("QueryObjects");
    Authenticate(OnQueryObjectsAuthenticationFinished);
  }
  
  function OnQueryObjectsAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Processing query...");
    _client.QueryObjects(
      sessionId,
      document.parameters.QueryObjects_query.value,
      document.parameters.QueryObjects_criteria.value,
      document.parameters.QueryObjects_sortBy.value,
      document.parameters.QueryObjects_attributes.value,
      document.parameters.QueryObjects_options.value,
      OnQueryObjectsFinished, OnRequestError);
  }

  function OnQueryObjectsFinished(result)
  {
    var resultElement = document.getElementById("QueryObjects_result");
    resultElement.value = JSON.stringify(result, null, '\t');

    LogOff(OnEndOperation);
  }

  function OnQueryObjectsAsXml()
  {
    OnStartOperation("QueryObjectsAsXml");
    Authenticate(OnQueryObjectsAsXmlAuthenticationFinished);
  }
  
  function OnQueryObjectsAsXmlAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Processing query...");
    _client.QueryObjectsAsXml(
      sessionId,
      document.parameters.QueryObjects_query.value,
      document.parameters.QueryObjects_criteria.value,
      document.parameters.QueryObjects_sortBy.value,
      document.parameters.QueryObjects_attributes.value,
      document.parameters.QueryObjects_options.value,
      OnQueryObjectsAsXmlFinished, OnRequestError);
  }

  function OnQueryObjectsAsXmlFinished(result)
  {
    var resultElement = document.getElementById("QueryObjects_result");
    resultElement.value = result;

    LogOff(OnEndOperation);
  }

  function OnQueryObjectIds()
  {
    OnStartOperation("QueryObjectIds");
    Authenticate(OnQueryObjectIdsAuthenticationFinished);
  }
  
  function OnQueryObjectIdsAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Processing query...");
    _client.QueryObjectIds(
      sessionId,
      document.parameters.QueryObjects_query.value,
      document.parameters.QueryObjects_criteria.value,
      document.parameters.QueryObjects_sortBy.value,
      document.parameters.QueryObjects_options.value,
      OnQueryObjectIdsFinished, OnRequestError);
  }

  function OnQueryObjectIdsFinished(result)
  {
    var resultElement = document.getElementById("QueryObjects_result");
    resultElement.value = result;

    LogOff(OnEndOperation);
  }

  function OnGetAttributeAsString()
  {
    OnStartOperation("GetAttributeAsString");
    Authenticate(OnGetAttributeAsStringAuthenticationFinished);
  }
  
  function OnGetAttributeAsStringAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Processing query...");
    _client.GetAttributeAsString(
      sessionId,
      document.parameters.GetAttributes_objectId.value,
      document.parameters.GetAttributes_attributes.value,
      document.parameters.GetAttributes_options.value,
      OnGetAttributeAsStringFinished, OnRequestError);
  }

  function OnGetAttributeAsStringFinished(result)
  {
    var resultElement = document.getElementById("GetAttributes_result");
    resultElement.value = result;

    LogOff(OnEndOperation);
  }
  
  function OnGetAttributesAsStringDictionary()
  {
    OnStartOperation("GetAttributesAsStringDictionary");
    Authenticate(OnGetAttributesAsStringDictionaryAuthenticationFinished);
  }
  
  function OnGetAttributesAsStringDictionaryAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Processing query...");
    _client.GetAttributesAsStringDictionary(
      sessionId,
      document.parameters.GetAttributes_objectId.value,
      document.parameters.GetAttributes_attributes.value,
      document.parameters.GetAttributes_options.value,
      OnGetAttributesAsStringDictionaryFinished, OnRequestError);
  }

  function OnGetAttributesAsStringDictionaryFinished(result)
  {
    var resultElement = document.getElementById("GetAttributes_result");
    resultElement.value = JSON.stringify(result, null, '\t');

    LogOff(OnEndOperation);
  }

  function OnGetPortalUrl()
  {
    OnStartOperation("GetPortalUrl");
    Authenticate(OnGetPortalUrlAuthenticationFinished);
  }
  
  function OnGetPortalUrlAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Processing query...");
    _client.GetPortalUrl(
      sessionId,
      document.parameters.GetPortalUrl_objectId.value,
      document.parameters.GetPortalUrl_viewName.value,
      document.parameters.GetPortalUrl_options.value,
      OnGetPortalUrlFinished, OnRequestError);
  }

  function OnGetPortalUrlFinished(result)
  {
    var resultElement = document.getElementById("GetPortalUrl_result");
    resultElement.value = result;
    OnGetPortalUrl_resultChanged();
    
    LogOff(OnEndOperation);
  }

  function OnCreateObject()
  {
    OnStartOperation("CreateObject");
    Authenticate(OnCreateObjectAuthenticationFinished);
  }

  function OnCreateObjectAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Creating object...");
    
    var attributes = GetTableAs2DimensionalArray(["CreateObject_aname", "CreateObject_avalue"]);

    var options = document.parameters.CreateObject_options.value;
    if (document.parameters.CreateObject_clearParents.checked)
      options = (options ? options + "," : "") + "ClearParents=true";

    _client.CreateObject(
      sessionId,
      document.parameters.CreateObject_namespaceId.value,
      document.parameters.CreateObject_objectTypeName.value,
      document.parameters.CreateObject_name.value,
      document.parameters.CreateObject_parents.value,
      attributes,
      options,
      OnCreateObjectFinished, OnRequestError);
  }

  function OnCreateObjectFinished(result)
  {
    var resultElement = document.getElementById("CreateObject_result");
    resultElement.value = "Created object id: " + result;

    LogOff(OnEndOperation);
  }

  function OnCreateCopy()
  {
    OnStartOperation("CreateCopy");
    Authenticate(OnCreateCopyAuthenticationFinished);
  }

  function OnCreateCopyAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Creating object copy...");
    
    var attributes = GetTableAs2DimensionalArray(["CreateCopy_aname", "CreateCopy_avalue"]);

    var options = document.parameters.CreateCopy_options.value;
    if (document.parameters.CreateCopy_recursive.checked)
      options = (options ? options + "," : "") + "Recursive=true";
    if (document.parameters.CreateCopy_clearParents.checked)
      options = (options ? options + "," : "") + "ClearParents=true";
    if (document.parameters.CreateCopy_keepOriginalParents.checked)
      options = (options ? options + "," : "") + "KeepOriginalParents=true";
    
    _client.CreateCopy(
      sessionId,
      document.parameters.CreateCopy_objectIds.value,
      document.parameters.CreateCopy_parents.value,
      attributes,
      options,
      OnCreateCopyFinished, OnRequestError);
  }

  function OnCreateCopyFinished(result)
  {
    var resultElement = document.getElementById("CreateCopy_result");
    resultElement.value = "Created object id: " + result;

    LogOff(OnEndOperation);
  }

  function OnDeleteObject()
  {
    OnStartOperation("DeleteObject");
    Authenticate(OnDeleteObjectAuthenticationFinished);
  }

  function OnDeleteObjectAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Deleting object(s)...");
    
    var options = document.parameters.DeleteObject_options.value;
    if (document.parameters.DeleteObject_recursive.checked)
      options = (options ? options + "," : "") + "Recursive=true";

    _client.DeleteObject(
      sessionId,
      document.parameters.DeleteObject_objectIds.value,
      options,
      OnDeleteObjectFinished, OnRequestError);
  }

  function OnDeleteObjectFinished(result)
  {
    LogOff(OnEndOperation);
  }

  function OnSetAttribute()
  {
    OnStartOperation("SetAttribute");
    Authenticate(OnSetAttributeAuthenticationFinished);
  }
  
  function OnSetAttributeAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Setting attribute...");
    _client.SetAttribute(
      sessionId,
      document.parameters.SetAttribute_objectIds.value,
      document.parameters.SetAttribute_attribute.value,
      document.parameters.SetAttribute_value.value,
      document.parameters.SetAttribute_options.value,
      OnSetAttributeFinished, OnRequestError);
  }

  function OnSetAttributeFinished(result)
  {
    LogOff(OnEndOperation);
  }

  function OnSetAttributes()
  {
    OnStartOperation("SetAttributes");
    Authenticate(OnSetAttributesAuthenticationFinished);
  }

  function OnSetAttributesAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Setting attributes...");
    
    var values = GetTableAs2DimensionalArray(["SetAttributes_aname", "SetAttributes_avalue"]);

    _client.SetAttributes(
      sessionId,
      document.parameters.SetAttributes_objectIds.value,
      values,
      document.parameters.SetAttributes_options.value,
      OnSetAttributesFinished, OnRequestError);
  }

  function OnSetAttributesFinished(result)
  {
    LogOff(OnEndOperation);
  }

  function OnSetBinaryData()
  {
    OnStartOperation("SetBinaryData");
    Authenticate(OnSetBinaryDataAuthenticationFinished);
  }

  function OnSetBinaryDataAuthenticationFinished(sessionId)
  {
    var form;
    _sessionId = sessionId;
    SetOperationState('Setting binary attribute...');

    form = $('#mainForm');

    form.ajaxForm({
      iframe:   true,
      dataType: 'xml',
      success:  OnSetBinaryDataCheckReturnValue,
      timeout:  10000, // 10 seconds, very conservative
      complete: OnSetBinaryDataError,
      url:      GetMethodURL('SetBinaryDataAsStream', '')
                + '?sessionId=' + encodeURIComponent(sessionId)
                + '&objectIds=' + encodeURIComponent(document.parameters.SetBinaryData_objectIds.value)
                + '&attribute=' + encodeURIComponent(document.parameters.SetBinaryData_attribute.value)
                + '&options='   + encodeURIComponent(document.parameters.SetBinaryData_options.value)
    });

    SetPasswordBoxType('text');
    form.submit();
  }

  function OnSetBinaryDataCheckReturnValue(data)
  {
    SetPasswordBoxType('password');

    var textNode = $(data).find('string');
    if (!textNode || textNode.length < 1) {
      // It appears we got an altogether invalid response.
      OnRequestError({ get_message: function() { return "No result returned from server"; } });
    } else {
      var response = textNode.text();
      if (response != '') // Blank response means success
        OnRequestError({ get_message: function() { return response; } });
    }
    LogOff(OnEndOperation);
  }

  function OnSetBinaryDataError(data, status)
  {
    SetPasswordBoxType('password');

    if (status == 'error') {
      // This actually happens when the timeout is triggered, which, in turn,
      // happens probably when WCF doesn't accept the file because it's too big
      OnRequestError({ get_message: function() {
          return "No result returned from server.\r\n" +
                 "It's possible that the file was too big.\r\n" +
                 "Check your Web.config's maxReceivedMessageSize setting";
        } });
      LogOff(OnEndOperation);
    }
  }

  function OnAddReference()
  {
    OnStartOperation("AddReference");
    Authenticate(OnAddReferenceAuthenticationFinished);
  }
  
  function OnAddReferenceAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Adding reference...");
    _client.AddReference(
      sessionId,
      document.parameters.ModifyReference_objectIds.value,
      document.parameters.ModifyReference_referenceAttribute.value,
      document.parameters.ModifyReference_targetObjectIds.value,
      document.parameters.ModifyReference_options.value,
      OnModifyReferenceFinished, OnRequestError);
  }

  function OnRemoveReference()
  {
    OnStartOperation("RemoveReference");
    Authenticate(OnRemoveReferenceAuthenticationFinished);
  }
  
  function OnRemoveReferenceAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Removing reference...");
    _client.RemoveReference(
      sessionId,
      document.parameters.ModifyReference_objectIds.value,
      document.parameters.ModifyReference_referenceAttribute.value,
      document.parameters.ModifyReference_targetObjectIds.value,
      document.parameters.ModifyReference_options.value,
      OnModifyReferenceFinished, OnRequestError);
  }

  function OnModifyReferenceFinished(result)
  {
    LogOff(OnEndOperation);
  }

  function OnSetSCMeasureValuesForMeasure()
  {
    OnStartOperation("OnSetSCMeasureValuesForMeasure");
    Authenticate(OnSetSCMeasureValuesForMeasureAuthenticationFinished);
  }
  
  function OnSetSCMeasureValuesForMeasureAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Processing query...");
    
    var values = GetTableAs2DimensionalArray(["SetSCMeasureValuesForMeasure_value_ss", "SetSCMeasureValuesForMeasure_value_date", "SetSCMeasureValuesForMeasure_value_value"]);

    _client.SetSCMeasureValuesForMeasure(
      sessionId,
      document.parameters.SetSCMeasureValuesForMeasure_measureId.value,
      values,
      document.parameters.SetSCMeasureValuesForMeasure_options.value,
      OnSetAttributeFinished, OnRequestError);
  }

  function OnSetSCMeasureValuesForModel()
  {
    OnStartOperation("OnSetSCMeasureValuesForModel");
    Authenticate(OnSetSCMeasureValuesForModelAuthenticationFinished);
  }
  
  function OnSetSCMeasureValuesForModelAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Processing query...");
    
    var values = GetTableAs2DimensionalArray(["SetSCMeasureValuesForModel_value_ms", "SetSCMeasureValuesForModel_value_scs", "SetSCMeasureValuesForModel_value_ss", "SetSCMeasureValuesForModel_value_date", "SetSCMeasureValuesForModel_value_value"]);

    _client.SetSCMeasureValuesForModel(
      sessionId,
      document.parameters.SetSCMeasureValuesForModel_modelName.value,
      values,
      document.parameters.SetSCMeasureValuesForModel_options.value,
      OnSetAttributeFinished, OnRequestError);
  }

  function OnSetAccessLevel()
  {
    OnStartOperation("SetAccessLevel");
    Authenticate(OnSetAccessLevelAuthenticationFinished);
  }
  
  function OnSetAccessLevelAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Setting access level...");

    _client.SetAccessLevel(
      sessionId,
      document.parameters.SetAccessLevel_objectIds.value,
      document.parameters.SetAccessLevel_user.value,
      document.parameters.SetAccessLevel_accessLevel.value,
      document.parameters.SetAccessLevel_removeAccess.checked ? "true" : "false",
      document.parameters.SetAccessLevel_options.value,
      OnSetAccessLevelFinished, OnRequestError);
  }

  function OnSetAccessLevelFinished(result)
  {
    LogOff(OnEndOperation);
  }

  function GetMethodURL(methodName, params)
  {
    return Sys.Net.WebRequest._createUrl(_client._get_path() + "/" + methodName, params); 
  }
  
  function GetURLForGetBinaryDataAsStream(sessionId, objectId, attribute, options)
  {
    return GetMethodURL("GetBinaryDataAsStream", { sessionId:sessionId, objectId:objectId, attribute:attribute, options:options });
  }

  function OnGetBinaryData()
  {
    OnStartOperation("GetBinaryData");
    Authenticate(OnGetBinaryDataAuthenticationFinished);
  }
  
  function OnGetBinaryDataAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Processing query...");
    _client.GetBinaryData(
      sessionId,
      document.parameters.GetBinaryData_objectId.value,
      document.parameters.GetBinaryData_attribute.value,
      document.parameters.GetBinaryData_options.value,
      OnGetBinaryDataFinished, OnRequestError);
  }

  function OnGetBinaryDataFinished(result)
  {
    if (result != null) {
      result = "Filename: " + result.FileName + "<br\/>" + 
               "MimeType: " + result.MimeType + "<br\/>" +
               "Content length: " + result.Content.length + "<br\/>" + 
               "Content:<br\/>" + ArrayToString(result.Content) + "<br\/>";
    }
    else
      result = "<null>";

    var resultElement = document.getElementById("GetBinaryData_result");
    resultElement.innerHTML = result;

    OnStartOperation("GetBinaryDataAsStream");
    SetOperationState("Processing secondary query...");

    var url = GetURLForGetBinaryDataAsStream(
      _sessionId,
      document.parameters.GetBinaryData_objectId.value,
      document.parameters.GetBinaryData_attribute.value,
      document.parameters.GetBinaryData_options.value);

    window.open(url);

    LogOff(OnEndOperation);
  }

  function GetURLForGetGraphAsStream(sessionId, objectId, options)
  {
    return GetMethodURL("GetGraphAsStream", { sessionId:sessionId, objectId:objectId, options:options });
  }

  function OnGetGraph()
  {
    OnStartOperation("GetGraph");
    Authenticate(OnGetGraphAuthenticationFinished);
  }

  function OnGetGraphAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Processing query...");
    _client.GetGraph(
      sessionId,
      document.parameters.GetGraph_objectId.value,
      document.parameters.GetGraph_options.value,
      OnGetGraphFinished, OnRequestError);
  }
  
  function OnGetGraphFinished(result)
  {
    if (result != null) {
      result = "Filename: " + result.FileName + "<br\/>" + 
               "MimeType: " + result.MimeType + "<br\/>" +
               "Content length: " + result.Content.length + "<br\/>" + 
               "Content:<br\/>" + ArrayToString(result.Content) + "<br\/>";
    }
    else
      result = "<null>";
    var resultElement = document.getElementById("GetGraph_result");
    resultElement.innerHTML = result;
    
    OnStartOperation("GetGraphAsStream");
    SetOperationState("Processing secondary query...");

    var url = GetURLForGetGraphAsStream(
      _sessionId,
      document.parameters.GetGraph_objectId.value,
      document.parameters.GetGraph_options.value);

    var resultImage = document.getElementById("GetGraph_resultImage");
    resultImage.src = url;

    LogOff(OnEndOperation);
  }
  
  function OnRunExpression()
  {
    OnStartOperation("RunExpression");
    Authenticate(OnRunExpressionAuthenticationFinished);
  }
  
  function OnRunExpressionAuthenticationFinished(sessionId) {
    _sessionId = sessionId;
    SetOperationState("Running expression...");
	
	var inputExpressions = $("#RunExpression_expression").val();
    if (inputExpressions == "") {
	  $("#RunExpression_resulttype").html("");
      $("#RunExpression_result").html("(Expression is empty)");
	  OnRunExpressionFinished();
	  return;
	}
	var expressionParts = inputExpressions.split("\n");
	var expressions = new Array();
	var variableNames = new Array();
	for (var i = 0; i < expressionParts.length; i++) {
	  if (expressionParts[i] == "") continue;
	  var equalSignIndex = expressionParts[i].indexOf("=");
	  if (equalSignIndex == -1 && expressionParts.length > 1 && i != expressionParts.length - 1) {
	    $("#RunExpression_result").text("Equals sign is missing.");
	    return;
	  } else if (equalSignIndex == -1) {
	    expressions.push($.trim(expressionParts[i]));
	    variableNames.push("unnamedexpression");
	    break;
	  }
	  var variableName = expressionParts[i].substring(0, equalSignIndex);
	  variableNames.push($.trim(variableName));
	  var expression = expressionParts[i].substring(equalSignIndex + 1);
	  expressions.push($.trim(expression));
	}
	
    $.ajax({
      "method": "POST",
	  "type": "POST",
      "url": "/QPRWebServicesExtensions/ExpressionEngine.svc/webHttp/Run",
      "dataType": "json",
      "contentType": "application/json; charset=utf-8",
      "data": JSON.stringify({
        "webServiceSessionId": sessionId,
        "expressionSet": expressions,
		"variableNameSet": variableNames
      }),
      "success": function (response) {
	    if (response.d.errorOccurred) {
		  $("#RunExpression_resulttype").html("");
          $("#RunExpression_result").html("CALCULATION ERROR: " + convertToHtml(response.d.errorMessage));
		} else {
          $("#RunExpression_resulttype").html("Result type: " + response.d.type);
          if (response.d.type.indexOf("[]") > -1) {
            if (response.d.arrayValue == null) $("#RunExpression_result").html("");
            var result = "";
            for (var i = 0; i < response.d.arrayValue.length;i++) {
              result = result + convertToHtml(response.d.arrayValue[i]) + "<br />";
            }
            $("#RunExpression_result").html(result);
          } else if (response.d.type == "DataSet") {
            $("#RunExpression_result").empty();
            $("#RunExpression_result").append("<table id=\"datasettable\"><thead></thead><tbody></tbody></table>");
            for (var headerNumber in response.d.datasetValue.headers) {
              var rowHtml = "";
              for (var columnNumber in response.d.datasetValue.headers[headerNumber].cells) {
                rowHtml = rowHtml + "<th>" + response.d.datasetValue.headers[headerNumber].cells[columnNumber].label + "</th>";
              }
              $("#RunExpression_result > table > thead").append("<tr>" + rowHtml + "</tr>");
            }

            for (var rowNumber in response.d.datasetValue.rows) {
              var rowHtml = "";
              for (var columnNumber in response.d.datasetValue.rows[rowNumber].cells) {
			  var cellValue = response.d.datasetValue.rows[rowNumber].cells[columnNumber].rawValue;
                rowHtml = rowHtml + "<td>" + (cellValue==null?"(null)":cellValue) + "</td>";
              }
              $("#RunExpression_result > table > tbody").append("<tr>" + rowHtml + "</tr>");
            }
          } else {
            $("#RunExpression_result").html(convertToHtml(response.d.value));
          }
		}
		OnRunExpressionFinished();
      },
      "error": function (response) {
        var responseText = "Unknown error. Please see the error message using browser debugging tools (press F12).";
		if (response != null && response.status == 404) {
		  responseText = "ERROR: QPR Web Services Extensions was not found. Perhaps it's not installed properly. Please make sure to run the QPR WSF Service Tester through IIS, i.e. use IIS port (80 or 443), not QPR Web Services Server port (by default 9002).";
		} else if (typeof(response) == "string") {
		  responseText = "ERROR: " + response;
		} else if (response instanceof XMLHttpRequest) {
		  try {
            responseText = "ERROR: " + JSON.parse(response.responseText).Message + " " + response.statusText + " (" + response.status + ")";
		  } catch (exception) {
		    responseText = "ERROR: " + response.responseText + " " + response.statusText + " (" + response.status + ")";
		  }
        }
        $("#RunExpression_resulttype").html("");
        $("#RunExpression_result").html(convertToHtml(responseText));
		OnRunExpressionFinished();
      }
    })
  }

  function convertToHtml(input) {
    return (input + "").replace(/\r\n/g, "<br/>").replace(/\s/g, "&nbsp;");
  }
  
  function OnRunExpressionFinished(result)
  {
    LogOff(OnEndOperation);
  }
  
  function HideAll()
  {
    for (var i = 0; i < _pages.length; ++i) {
      var oDiv = document.getElementById(_pages[i] + "_Parameters");
      oDiv.style.display = "none";
    }
  }

  function oGetPageDiv(pageLabel)
  {
    return document.getElementById(pageLabel + "_Parameters");
  }
  
  function sGetPageButtonHTML(pageLabel)
  {
    return sGetButtonHTML(pageLabel, "javascript:ShowPage(\"" + pageLabel + "\")", (_selectedPage == pageLabel) ? "SelectedButton" : "Button");
  }
  
  function GeneratePageLinks()
  {
    var html = "";
    for (var i = 0; i < _pages.length; ++i)
      html += sGetPageButtonHTML(_pages[i]);

    var div = document.getElementById("pageSelector");
    div.innerHTML = html;
  }
      
  function ShowPage(pageLabel)
  {
    HideAll();
    var oDiv = oGetPageDiv(pageLabel);
    oDiv.style.display = "block";
    _selectedPage = pageLabel;
    GeneratePageLinks();
    if (eval("typeof(" + pageLabel + "_OnShowPage) === \"function\""))
      eval(pageLabel + "_OnShowPage()");
  }
 
  function GenerateTable(numRows, labels, names, initValues)
  {
    var sResult = "<table style=\"width: 100%\"><tr>";
    for (var i = 0; i < labels.length; ++i)
      sResult += "<th>" + labels[i] + "<\/th>";
    sResult += "<\/tr>";
    
    for (var i = 0; i < numRows; ++i) {
      sResult += "<tr>";
      for (var j = 0; j < names.length; ++j) {
        sResult += "<td>";
        if (initValues[i]) {
          sResult += "<input type=\"text\" " +
                            "name=\"" + names[j] + (i + 1).toString() + "\" " +
                            "value=\"" + initValues[i][j] + "\" " +
                            "style=\"width:100%\" />";
        }
        else {
          sResult += "<input type=\"text\" " +
                            "name=\"" + names[j] + (i + 1).toString() + "\" " +
                            "value=\"\" " +
                            "style=\"width:100%\" />";
        }
        sResult += "<\/td>";
      }
      sResult += "<\/tr>";
    }
    sResult += "<\/table>";
    return sResult;
  }

  function SSOEnabled()
  {
    return document.parameters.Authentication_useSSO.checked;
  }
    
  function OnAuthenticationUseSSOClicked()
  {
    var div = document.getElementById("Authentication_LogonInformation");
    if (SSOEnabled())
      div.style.display = "none";
    else
      div.style.display = "block";
  }
  
  var _copyTargetControl;

  function OnCopyIdsFromQueryObjectsResults(copyTargetControl)
  {
    _copyTargetControl = copyTargetControl;
    OnStartOperation("CopyIdsFromQueryObjectsResults");
    Authenticate(OnCopyIdsFromQueryObjectsResultsAuthenticationFinished);
  }

  function OnCopyIdsFromQueryObjectsResultsAuthenticationFinished(sessionId)
  {
    _sessionId = sessionId;
    SetOperationState("Processing query...");
    _client.QueryObjects(
      sessionId,
      document.parameters.QueryObjects_query.value,
      document.parameters.QueryObjects_criteria.value,
      document.parameters.QueryObjects_sortBy.value,
      document.parameters.QueryObjects_attributes.value,
      document.parameters.QueryObjects_options.value,
      OnCopyIdsFromQueryObjectsQueryFinished, OnRequestError);
  }

  function GetObjectIdsFromJSONResultSet(resultSet)
  {
    SetOperationState("Processing query results...");
    var result = "";
    var resultObjects = resultSet.ChildElements;
    if (resultObjects) {
      for (var i = 0; i < resultObjects.length; ++i) {
        var resultObject = resultObjects[i];
        result = (result ? result + "," : "") + resultObject.Id;
      }
    }
    return result;
  }
  
  function OnCopyIdsFromQueryObjectsQueryFinished(result)
  {
    _copyTargetControl.value = GetObjectIdsFromJSONResultSet(result);
    LogOff(OnEndOperation);
  }
  
  function OnLoad()
  {
    var sURL = document.location.href;
    ShowPage("QueryObjects");
    try {
      _client = new www.qpr.com.ns.IService();
    }
    catch (e) {
      alert("Error initializing main service connection. Redirecting to main service page.");
      document.location = "MainService.svc";
    }
    _client.set_path(sURL.substring(0, sURL.lastIndexOf('/')) +
                     '/MainService.svc/webHttp');
  }
-->
</script>
</head>
<body onload="OnLoad()">
  <form id="ScriptForm" runat="server" action="#">
    <asp:scriptmanager id="scrptMgr" runat="server">
      <services>
        <asp:servicereference path="~/MainService.svc/webHttp" />
      </services>
    </asp:scriptmanager>
  </form>
  <form name="parameters" style="width:100%;" action="#" method="POST" enctype="multipart/form-data" accept-charset="UTF-8" id="mainForm">
    <div id="pageSelector">
    </div>
    <div class="Clearer"></div>
    <hr/>

    <div id="Authentication_Parameters" style="display: none;">
      <table style="width:100%;">
        <tr>
          <th style="white-space:nowrap;">
            Use single sign-on:
          </th>
          <td style="width:100%;"> 
            <input type="checkbox" name="Authentication_useSSO" onclick="OnAuthenticationUseSSOClicked()" />
          </td>
        </tr>
        <tr>
          <td style="width:100%;" colspan="2">
            <table id="Authentication_LogonInformation" style="width:100%;">
              <tr>
                <th style="white-space:nowrap;">
                  Logon name:
                </th>
                <td style="width:100%;"> 
                  <input type="text" name="Authentication_logonName" value="qpr" style="width:100%;" />
                </td>
              </tr>
              <tr>
                <th style="white-space:nowrap;">
                  Password:
                </th>
                <td style="width:100%;"> 
                  <input type="password" name="Authentication_password" value="demo" style="width:100%;" />
                </td>
              </tr>
            </table>
          </td>
        </tr>
      </table>
    </div>

    <div id="QueryObjects_Parameters" style="display: none;">
      <table style="width:100%;">
        <tr>
          <th style="white-space:nowrap; vertical-align:top;">
            Query:
          </th>
          <td style="width:100%;"> 
            <textarea id="QueryObjects_query" name="QueryObjects_query" rows="25" cols="80" style="width:100%; height:120px;">[PO].Comment.ParentObjects</textarea>
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Criteria:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="QueryObjects_criteria" value="" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Sort by:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="QueryObjects_sortBy" value="" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap; vertical-align:top;">
            Attributes:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="QueryObjects_attributes" value="name" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Options:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="QueryObjects_options" value="" style="width:100%;" />
          </td>
        </tr>
      </table>
      <input type="button" name="Ok" value="QueryObjects" onclick="javascript:OnQueryObjects()" />
      <input type="button" name="Ok" value="QueryObjectsAsXml" onclick="javascript:OnQueryObjectsAsXml()" />
      <input type="button" name="Ok" value="QueryObjectIds" onclick="javascript:OnQueryObjectIds()" />
      <br />
      <textarea id="QueryObjects_result" rows="25" cols="80" style="width:100%; height:500px;"></textarea>
    </div>

    <div id="GetAttributes_Parameters" style="display: none;">
      <table style="width:100%;">
        <tr>
          <th style="white-space:nowrap; vertical-align:top;">
            Object id:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="GetAttributes_objectId" value="PO.0.941136658" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Attributes:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="GetAttributes_attributes" value="embeddedfilename" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Options:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="GetAttributes_options" value="" style="width:100%;" />
          </td>
        </tr>
      </table>
      <input type="button" name="Ok" value="GetAttributeAsString" onclick="javascript:OnGetAttributeAsString()" />
      <input type="button" name="Ok" value="GetAttributesAsStringDictionary" onclick="javascript:OnGetAttributesAsStringDictionary()" />
      <br />
      <textarea id="GetAttributes_result" rows="25" cols="80" style="width:100%; height:500px;"></textarea>
    </div>
    
    <div id="GetPortalUrl_Parameters" style="display: none;">
      <table style="width:100%;">
        <tr>
          <th style="white-space:nowrap; vertical-align:top;">
            Object id:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="GetPortalUrl_objectId" value="PO" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            View name:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="GetPortalUrl_viewName" value="details" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Options:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="GetPortalUrl_options" value="" style="width:100%;" />
          </td>
        </tr>
      </table>
      <input type="button" name="Ok" value="GetPortalUrl" onclick="javascript:OnGetPortalUrl()" />
      <br />

<script type="text/javascript">
  function OnGetPortalUrl_resultChanged()
  {
    var tableUrl = document.getElementById("GetPortalUrl_tableUrl");
    var result = document.getElementById("GetPortalUrl_result");
    var url = result.value;
    if (url)
      tableUrl.style.display = "block";
    else
      tableUrl.style.display = "none";
  }
  
  function GetPortalUrl_OnOpenUrl()
  {
    var result = document.getElementById("GetPortalUrl_result");
    var url = result.value;
    window.open(url);
  }
  
  function GetPortalUrl_OnShowPage()
  {
    OnGetPortalUrl_resultChanged();
  }
</script>

      <table id="GetPortalUrl_tableUrl"><tr><td style="width: 100%">
        <input type="text" id="GetPortalUrl_result" style="width:100%;" onchange="OnGetPortalUrl_resultChanged()" readonly="readonly" />
      </td><td>
        <input type="button" value="Open Url" onclick="javascript:GetPortalUrl_OnOpenUrl()" />
      </td></tr></table>
    </div>
    
    <div id="GetBinaryData_Parameters" style="display: none;">
      <table style="width:100%;">
        <tr>
          <th style="white-space:nowrap;">
            Object id:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="GetBinaryData_objectId" value="PO.0.686650742" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Attribute:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="GetBinaryData_attribute" value="embeddeddata" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Options:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="GetBinaryData_options" value="" style="width:100%;" />
          </td>
        </tr>
      </table>
      <input type="button" name="Ok" value="GetBinaryData" onclick="javascript:OnGetBinaryData()" />
      <br />
      <div id="GetBinaryData_result"></div>
    </div>

    <div id="GetGraph_Parameters" style="display: none;">
      <table style="width:100%;">
        <tr>
          <th style="white-space:nowrap; vertical-align:top;">
            Object id:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="GetGraph_objectId" value="PG.1300285547.699583604" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Options:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="GetGraph_options" value="" style="width:100%;" />
          </td>
        </tr>
      </table>
      <input type="button" name="GetGraph" value="GetGraph" onclick="javascript:OnGetGraph()" />
      <br />
      <div id="GetGraph_result"></div>
      <img id="GetGraph_resultImage" src="#" alt="GetGraph result image" />
    </div>

    <div id="CreateObject_Parameters" style="display: none;">
      <table style="width:100%;">
        <tr>
          <th style="white-space:nowrap; vertical-align:top;">
            Namespace id:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="CreateObject_namespaceId" value="PO" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Object type name:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="CreateObject_objectTypeName" value="risk" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Name:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="CreateObject_name" value="WS Test" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Clear parents:
          </th>
          <td style="width:100%;"> 
            <input type="checkbox" name="CreateObject_clearParents" checked="checked" />
          </td>
        </tr>
        <tr id="trCreateObject_parents">
          <th style="white-space:nowrap;">
            Parents:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="CreateObject_parents" value="" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap; vertical-align:top;">
            Attributes:
          </th>
          <td style="width:100%;"> 
<script type="text/javascript">
  var sHtml = GenerateTable(5,
                            ["Name", "Value"], 
                            ["CreateObject_aname", "CreateObject_avalue"],
                            [["description", "Hello, this is CreateObject from QPR WS!"],
                             ["datestamp", "2009-01-29"]]);
  document.write(sHtml);
</script>
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Options:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="CreateObject_options" value="" style="width:100%;" />
          </td>
        </tr>
      </table>
      <input type="button" name="Ok" value="CreateObject" onclick="javascript:OnCreateObject()" />
      <br />
      <textarea id="CreateObject_result" rows="25" cols="80" style="width:100%; height:500px;"></textarea>
    </div>

    <div id="CreateCopy_Parameters" style="display: none;">
      <table style="width:100%;">
        <tr>
          <th style="white-space:nowrap;">
            Object id(s):
          </th>
          <td style="width:100%;"> 
            <table style="width:100%;">
              <tr>
                <td style="width:100%;">
                  <input type="text" name="CreateCopy_objectIds" value="PO.0.1190536205" style="width:100%;" />
                </td>
                <td>
                  <input type="button" value="Copy from QueryObjects results" onclick="OnCopyIdsFromQueryObjectsResults(document.parameters.CreateCopy_objectIds)" />
                </td>
              </tr>
            </table>
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Keep original parents:
          </th>
          <td style="width:100%;"> 
            <input type="checkbox" name="CreateCopy_keepOriginalParents" checked="checked" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Clear parents:
          </th>
          <td style="width:100%;"> 
            <input type="checkbox" name="CreateCopy_clearParents" />
          </td>
        </tr>
        <tr id="trCreateCopy_parents">
          <th style="white-space:nowrap;">
            Parents:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="CreateCopy_parents" value="" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap; vertical-align:top;">
            Attributes:
          </th>
          <td style="width:100%;"> 
<script type="text/javascript">
  var sHtml = GenerateTable(5,
                            ["Name", "Value"], 
                            ["CreateCopy_aname", "CreateCopy_avalue"],
                            [["name", "Copy"],
                             ["description", "Hello, this is CreateCopy from QPR WS!"],
                             ["datestamp", "2009-01-29"]]);
  document.write(sHtml);
</script>
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Do recursive copy:
          </th>
          <td style="width:100%;"> 
            <input type="checkbox" name="CreateCopy_recursive" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Options:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="CreateCopy_options" value="" style="width:100%;" />
          </td>
        </tr>
      </table>
      <input type="button" name="Ok" value="CreateCopy" onclick="javascript:OnCreateCopy()" />
      <br />
      <textarea id="CreateCopy_result" rows="25" cols="80" style="width:100%; height:500px;"></textarea>
    </div>

    <div id="DeleteObject_Parameters" style="display: none;">
      <table style="width:100%;">
        <tr>
          <th style="white-space:nowrap;">
            Object id(s):
          </th>
          <td style="width:100%;"> 
            <table style="width:100%;">
              <tr>
                <td style="width:100%;">
                  <input type="text" name="DeleteObject_objectIds" value="PO.0.1661218420" style="width:100%;" />
                </td>
                <td>
                  <input type="button" value="Copy from QueryObjects results" onclick="OnCopyIdsFromQueryObjectsResults(document.parameters.DeleteObject_objectIds)" />
                </td>
              </tr>
            </table>
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Do recursive delete:
          </th>
          <td style="width:100%;"> 
            <input type="checkbox" name="DeleteObject_recursive" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Options:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="DeleteObject_options" value="" style="width:100%;" />
          </td>
        </tr>
      </table>
      <input type="button" name="Ok" value="DeleteObject" onclick="javascript:OnDeleteObject()" />
    </div>

    <div id="SetAttribute_Parameters" style="display: none;">
      <table style="width:100%;">
        <tr>
          <th style="white-space:nowrap;">
            Object id(s):
          </th>
          <td style="width:100%;"> 
            <table style="width:100%;">
              <tr>
                <td style="width:100%;">
                  <input type="text" name="SetAttribute_objectIds" value="PO.0.1869526071" style="width:100%;" />
                </td>
                <td>
                  <input type="button" value="Copy from QueryObjects results" onclick="OnCopyIdsFromQueryObjectsResults(document.parameters.SetAttribute_objectIds)" />
                </td>
              </tr>
            </table>
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Attribute:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="SetAttribute_attribute" value="" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap; vertical-align:top;">
            Value:
          </th>
          <td style="width:100%;"> 
            <textarea id="SetAttribute_value" name="SetAttribute_value" rows="10" cols="80" style="width:100%; height:120px;"></textarea>
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Options:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="SetAttribute_options" value="" style="width:100%;" />
          </td>
        </tr>
      </table>
      <input type="button" name="Ok" value="SetAttribute" onclick="javascript:OnSetAttribute()" />
    </div>

    <div id="SetAttributes_Parameters" style="display: none;">
      <table style="width:100%;">
        <tr>
          <th style="white-space:nowrap;">
            Object id(s):
          </th>
          <td style="width:100%;"> 
            <table style="width:100%;">
              <tr>
                <td style="width:100%;">
                  <input type="text" name="SetAttributes_objectIds" value="PO.0.1190536205" style="width:100%;" />
                </td>
                <td>
                  <input type="button" value="Copy from QueryObjects results" onclick="OnCopyIdsFromQueryObjectsResults(document.parameters.SetAttributes_objectIds)" />
                </td>
              </tr>
            </table>
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap; vertical-align:top;">
            Attributes:
          </th>
          <td style="width:100%;"> 
<script type="text/javascript">
  var sHtml = GenerateTable(5,
                            ["Name", "Value"], 
                            ["SetAttributes_aname", "SetAttributes_avalue"],
                            [["description", "Hello, this is SetAttributes from QPR WS!"],
                             ["datestamp", "2009-01-29"]]);
  document.write(sHtml);
</script>
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Options:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="SetAttributes_options" value="" style="width:100%;" />
          </td>
        </tr>
      </table>
      <input type="button" name="Ok" value="SetAttributes" onclick="javascript:OnSetAttributes()" />
    </div>

    <div id="SetBinaryData_Parameters" style="display: none;">
      <table style="width:100%;">
        <tr>
          <th style="white-space:nowrap;">
            Object id(s):
          </th>
          <td style="width:100%;"> 
            <table style="width:100%;">
              <tr>
                <td style="width:100%;">
                  <input type="text" name="SetBinaryData_objectIds" value="PO.0.686650742" style="width:100%;" />
                </td>
                <td>
                  <input type="button" value="Copy from QueryObjects results" onclick="OnCopyIdsFromQueryObjectsResults(document.parameters.SetBinaryData_objectIds)" />
                </td>
              </tr>
            </table>
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap; vertical-align:top;">
            Attribute:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="SetBinaryData_attribute" value="embeddeddata" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap; vertical-align:top;">
            File:
          </th>
          <td style="width:100%;"> 
            <input type="file" name="SetBinaryData_file" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Options:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="SetBinaryData_options" value="" style="width:100%;" />
          </td>
        </tr>
      </table>
      <input type="button" name="Ok" value="SetBinaryData" onclick="javascript:OnSetBinaryData()" />
    </div>

    <div id="ModifyReference_Parameters" style="display: none;">
      <table style="width:100%;">
        <tr>
          <th style="white-space:nowrap;">
            Object id(s):
          </th>
          <td style="width:100%;"> 
            <table style="width:100%;">
              <tr>
                <td style="width:100%;">
                  <input type="text" name="ModifyReference_objectIds" value="PO.0.1869526071" style="width:100%;" />
                </td>
                <td>
                  <input type="button" value="Copy from QueryObjects results" onclick="OnCopyIdsFromQueryObjectsResults(document.parameters.ModifyReference_objectIds)" />
                </td>
              </tr>
            </table>
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Reference attribute:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="ModifyReference_referenceAttribute" value="parentobjects" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Target object id(s):
          </th>
          <td style="width:100%;"> 
            <table style="width:100%;">
              <tr>
                <td style="width:100%;">
                  <input type="text" name="ModifyReference_targetObjectIds" value="PO.0.1869526071" style="width:100%;" />
                </td>
                <td>
                  <input type="button" value="Copy from QueryObjects results" onclick="OnCopyIdsFromQueryObjectsResults(document.parameters.ModifyReference_targetObjectIds)" />
                </td>
              </tr>
            </table>
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Options:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="ModifyReference_options" value="" style="width:100%;" />
          </td>
        </tr>
      </table>
      <input type="button" name="Ok" value="AddReference" onclick="javascript:OnAddReference()" />
      <input type="button" name="Ok" value="RemoveReference" onclick="javascript:OnRemoveReference()" />
    </div>

    <div id="SetAccessLevel_Parameters" style="display: none;">
      <table style="width:100%;">
        <tr>
          <th style="white-space:nowrap;">
            Object id(s):
          </th>
          <td style="width:100%;"> 
            <table style="width:100%;">
              <tr>
                <td style="width:100%;">
                  <input type="text" name="SetAccessLevel_objectIds" value="SC.1938773693.202" style="width:100%;" />
                </td>
                <td>
                  <input type="button" value="Copy from QueryObjects results" onclick="OnCopyIdsFromQueryObjectsResults(document.parameters.SetAccessLevel_objectIds)" />
                </td>
              </tr>
            </table>
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            User:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="SetAccessLevel_user" value="" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Access Level:
          </th>
          <td style="width:100%;"> 
            <select name="SetAccessLevel_accessLevel" size="1">
              <option value="-1" selected="selected">
                None
              </option>
              <option value="0">
                View
              </option>
              <option value="1">
                Update
              </option>
              <option value="2">
                Full
              </option>
              <option value="-2">
                ModelUser
              </option>
              <option value="-3">
                ModelAdministrator
              </option>
            </select>
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Remove access:
          </th>
          <td style="width:100%;"> 
            <input type="checkbox" name="SetAccessLevel_removeAccess" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Options:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="SetAccessLevel_options" value="" style="width:100%;" />
          </td>
        </tr>
      </table>
      <input type="button" name="Ok" value="SetAccessLevel" onclick="javascript:OnSetAccessLevel()" />
    </div>

    <div id="SetSCMeasureValuesForMeasure_Parameters" style="display: none;">
      <table style="width:100%;">
        <tr>
          <th style="white-space:nowrap; vertical-align:top;">
            Object id:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="SetSCMeasureValuesForMeasure_measureId" value="SC.1.337" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap; vertical-align:top;">
            Values:
          </th>
          <td style="width:100%;"> 
<script type="text/javascript">
  var sHtml = GenerateTable(5,
                            ["seriessymbol", "date", "value"], 
                            ["SetSCMeasureValuesForMeasure_value_ss", "SetSCMeasureValuesForMeasure_value_date", "SetSCMeasureValuesForMeasure_value_value"],
                            [["ACT", "2002-09-29T00:00:00", "10"],
                             ["ACT", "2002-10-29T00:00:00", "10"],
                             ["ACT", "2002-11-29T00:00:00", "10"],
                             ["ACT", "2002-12-29T00:00:00", "10"],
                             ["ACT", "2003-01-29T00:00:00", "10"]]);
  document.write(sHtml);
</script>
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Options:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="SetSCMeasureValuesForMeasure_options" value="" style="width:100%;" />
          </td>
        </tr>
      </table>
      <input type="button" name="Ok" value="SetSCMeasureValuesForMeasure" onclick="javascript:OnSetSCMeasureValuesForMeasure()" />
    </div>

    <div id="SetSCMeasureValuesForModel_Parameters" style="display: none;">
      <table style="width:100%;">
        <tr>
          <th style="white-space:nowrap; vertical-align:top;">
            Object id:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="SetSCMeasureValuesForModel_modelName" value="Government" style="width:100%;" />
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap; vertical-align:top;">
            Values:
          </th>
          <td style="width:100%;"> 
<script type="text/javascript">
  var sHtml = GenerateTable(5,
                            ["measuresymbol", "scorecardsymbol", "seriessymbol", "date", "value"], 
                            ["SetSCMeasureValuesForModel_value_ms", "SetSCMeasureValuesForModel_value_scs", "SetSCMeasureValuesForModel_value_ss", "SetSCMeasureValuesForModel_value_date", "SetSCMeasureValuesForModel_value_value"],
                            [["MEA337", "SC308", "ACT", "2002-09-29T00:00:00", "10"],
                             ["MEA337", "SC308", "ACT", "2002-10-29T00:00:00", "10"],
                             ["MEA337", "SC308", "ACT", "2002-11-29T00:00:00", "10"],
                             ["MEA337", "SC308", "ACT", "2002-12-29T00:00:00", "10"],
                             ["MEA337", "SC308", "ACT", "2003-01-29T00:00:00", "10"]]);
  document.write(sHtml);
</script>
          </td>
        </tr>
        <tr>
          <th style="white-space:nowrap;">
            Options:
          </th>
          <td style="width:100%;"> 
            <input type="text" name="SetSCMeasureValuesForModel_options" value="" style="width:100%;" />
          </td>
        </tr>
      </table>
      <input type="button" name="Ok" value="SetSCMeasureValuesForModel" onclick="javascript:OnSetSCMeasureValuesForModel()" />
    </div>

	 <div id="RunExpression_Parameters">
      <div style="font-weight:bold;margin-bottom:3px;">Expressions:</div>
      <textarea id="RunExpression_expression" name="RunExpression_expression" rows="25" cols="80" style="width:100%; height:150px;">
var1=GetAttribute('PO.0.1','name','')
var2=if(ToLower([var1])='discussion', 'Ok', 'Error')</textarea>     
      <input type="button" name="Ok" value="Run" onclick="javascript:OnRunExpression()" style="margin: 5px 10px 10px 0px;" />
      <div id="RunExpression_resulttype" style="display: inline;"></div>
	  <div id="RunExpression_result" style="width:100%;margin-bottom:10px;"></div>
    </div>
	
  </form>
  Query state: <span id="OperationState">Idle</span><br/>
  <span id="ElapsedTime"></span> 
</body>
</html>